% Version 1.0.0 10/5/2020
global bUseDiary
global bDeleteIfExists
global order

bUseDiary = true;
bDeleteIfExists = false; % or false
selIdx = 0; % note a zero value will execute all the models
runNum = 1;
bShutdown = false;
order = 7;

tic;

% build lower limit values
lstC = zeros(order,1);
for i=1:order
  if i>1
    lstC(i) = (i-1)*pi;
  else
    lstC(1) = 0.1;
  end
end
lstAs = zeros(order,1);
lstBs = 0.1 + zeros(order,1);
lstOs = -2 + zeros(order,1);
% Lb = [0.1 pi  2*pi 0 0 0 0.1 0.1 0.1 -2 -2 -2];
Lb = [lstC; lstAs; lstBs; lstOs]';
% build upper limit values
lstC = zeros(order,1);
for i=1:order
  lstC(i) = i*pi;
end
lstAs = 1 + zeros(order,1);
lstBs = 3 + zeros(order,1);
lstOs = 2 + zeros(order,1);  
% Ub = [pi 2*pi 3*pi 1 1 1 3 3 3 2 2 2];  
Ub = [lstC; lstAs; lstBs; lstOs]';

if selIdx==0 || selIdx==1
  gx = @(i,A,B)A+B*i;
  FourierShammasSeries2(@(x)acos(x),gx,[0:.01:1],Lb,Ub,runNum,"arccos(x)","arccos_1.txt")
  FourierShammasSeries2(@(x)asin(x),gx,[0:.01:1],Lb,Ub,runNum,"arcsin(x)","arcsin_1.txt")
  FourierShammasSeries2(@(x)atan(x),gx,[0:.01:1],Lb,Ub,runNum,"arctan(x)","arctan_1.txt")
  FourierShammasSeries2(@(x)tan(x),gx,[0:.01:1],Lb,Ub,runNum,"tan(x)","tan_1.txt")
  FourierShammasSeries2(@(x)sinh(x),gx,[0:.01:5],Lb,Ub,runNum,"sinh(x)","sinh_1.txt")
  FourierShammasSeries2(@(x)cosh(x),gx,[0:.01:5],Lb,Ub,runNum,"cosh(x)","cosh_1.txt")
  FourierShammasSeries2(@(x)tanh(x),gx,[0:.01:3],Lb,Ub,runNum,"tanh(x)","tanh_1.txt")
  FourierShammasSeries2(@(x)erf(x),gx,[0:.01:2.1],Lb,Ub,runNum,"erf(x)","erf_1.txt")
  FourierShammasSeries2(@(x)exp(x),gx,[0:.01:2],Lb,Ub,runNum,"exp(x)","exp_1.txt")
  FourierShammasSeries2(@(x)log(x),gx,[1:.01:10],Lb,Ub,runNum,"ln(x)","ln_1.txt")
  FourierShammasSeries2(@(x)log10(x),gx,[1:.01:10],Lb,Ub,runNum,"log(x)","log_1.txt")
  FourierShammasSeries2(@(x)10.^x,gx,[0:.01:1],Lb,Ub,runNum,"10^x","pwr10_1.txt")
  FourierShammasSeries2(@(x)tinv(0.95,x),gx,[2:0.1:100],Lb,Ub,runNum,"tinv(0.95,x)","tinv1_1.txt")
  FourierShammasSeries2(@(x)tinv(0.975,x),gx,[2:0.1:100],Lb,Ub,runNum,"tinv(0.975,x)","tinv2_1.txt")
  FourierShammasSeries2(@(x)log10(gamma(x)),gx,[2:0.1:100],Lb,Ub,runNum,"log10Gamma(x)","log10Gamma_1.txt")
  FourierShammasSeries2(@(x)digamma(x),gx,[2:0.1:100],Lb,Ub,runNum,"digamma(x)","digamma_1.txt")
  FourierShammasSeries2(@(x)trigamma(x),gx,[1:0.1:100],Lb,Ub,runNum,"trigamma(x)","trigamma_1.txt")
  FourierShammasSeries2(@(x)besselj(0,x),gx,[2:0.1:30],Lb,Ub,runNum,"J0(x)","J0x_1.txt")
  FourierShammasSeries2(@(x)besselj(1,x),gx,[0:0.1:30],Lb,Ub,runNum,"J1(x)","J1x_1.txt")
  FourierShammasSeries2(@(x)besselj(2,x),gx,[0:0.1:30],Lb,Ub,runNum,"J2(x)","J2x_1.txt")
  FourierShammasSeries2(@(x)besselj(3,x),gx,[0:0.1:30],Lb,Ub,runNum,"J3(x)","J3x_1.txt")
  FourierShammasSeries2(@(x)besselj(4,x),gx,[0:0.1:30],Lb,Ub,runNum,"J4(x)","J4x_1.txt")
  FourierShammasSeries2(@(x)besselj(5,x),gx,[0:0.1:30],Lb,Ub,runNum,"J5(x)","J5x_1.txt")
  FourierShammasSeries2(@(x)integral(@(z)sin(z.^2),0,x),gx,[1:0.01:5],Lb,Ub,runNum,"FresnelSine(x)","FresnelSine_1.txt")
  FourierShammasSeries2(@(x)integral(@(z)cos(z.^2),0,x),gx,[0.5:0.01:5],Lb,Ub,runNum,"FresnelCosine(x)","FresnelCosine_1.txt")
  FourierShammasSeries2(@(x)integral(@(z)sin(z)./z,0,x),gx,[1.3:0.1:20],Lb,Ub,runNum,"Si(x)","Si_1.txt")
  FourierShammasSeries2(@(x)0.57721566+log(x)-integral(@(z)(1-cos(z))./z,0,x),gx,[0.5:0.1:20],Lb,Ub,runNum,"Ci(x)","CI_1.txt")
  FourierShammasSeries2(@(x)asinh(x),gx,[0:0.1:100],Lb,Ub,runNum,"asinh(x)","asinh_1.txt")
  FourierShammasSeries2(@(x)acosh(x),gx,[1:0.1:100],Lb,Ub,runNum,"acosh(x)","acosh_1.txt")
  FourierShammasSeries2(@(x)atanh(x),gx,[0:0.001:0.999],Lb,Ub,runNum,"atanh(x)","atanh_1.txt")
end

if selIdx==0 || selIdx==2
  gx = @(i,A,B)A+B/i;
  FourierShammasSeries2(@(x)acos(x),gx,[0:.01:1],Lb,Ub,runNum,"arccos(x)","arccos_2.txt")
  FourierShammasSeries2(@(x)asin(x),gx,[0:.01:1],Lb,Ub,runNum,"arcsin(x)","arcsin_2.txt")
  FourierShammasSeries2(@(x)atan(x),gx,[0:.01:1],Lb,Ub,runNum,"arctan(x)","arctan_2.txt")
  FourierShammasSeries2(@(x)tan(x),gx,[0:.01:1],Lb,Ub,runNum,"tan(x)","tan_2.txt")
  FourierShammasSeries2(@(x)sinh(x),gx,[0:.01:5],Lb,Ub,runNum,"sinh(x)","sinh_2.txt")
  FourierShammasSeries2(@(x)cosh(x),gx,[0:.01:5],Lb,Ub,runNum,"cosh(x)","cosh_2.txt")
  FourierShammasSeries2(@(x)tanh(x),gx,[0:.01:3],Lb,Ub,runNum,"tanh(x)","tanh_2.txt")
  FourierShammasSeries2(@(x)erf(x),gx,[0:.01:2.1],Lb,Ub,runNum,"erf(x)","erf_2.txt")
  FourierShammasSeries2(@(x)exp(x),gx,[0:.01:2],Lb,Ub,runNum,"exp(x)","exp_2.txt")
  FourierShammasSeries2(@(x)log(x),gx,[1:.01:10],Lb,Ub,runNum,"ln(x)","ln_2.txt")
  FourierShammasSeries2(@(x)log10(x),gx,[1:.01:10],Lb,Ub,runNum,"log(x)","log_2.txt")
  FourierShammasSeries2(@(x)10.^x,gx,[0:.01:1],Lb,Ub,runNum,"10^x","pwr10_2.txt")
  FourierShammasSeries2(@(x)tinv(0.95,x),gx,[2:0.1:100],Lb,Ub,runNum,"tinv(0.95,x)","tinv1_2.txt")
  FourierShammasSeries2(@(x)tinv(0.975,x),gx,[2:0.1:100],Lb,Ub,runNum,"tinv(0.975,x)","tinv2_2.txt")
  FourierShammasSeries2(@(x)log10(gamma(x)),gx,[2:0.1:100],Lb,Ub,runNum,"log10Gamma(x)","log10Gamma_2.txt")
  FourierShammasSeries2(@(x)digamma(x),gx,[2:0.1:100],Lb,Ub,runNum,"digamma(x)","diamma_2.txt")
  FourierShammasSeries2(@(x)trigamma(x),gx,[1:0.1:100],Lb,Ub,runNum,"trigamma(x)","trigamma_2.txt")
  FourierShammasSeries2(@(x)trigamma(x),gx,[1:0.1:100],Lb,Ub,runNum,"trigamma(x)","trigamma_2.txt")
  FourierShammasSeries2(@(x)besselj(0,x),gx,[2:0.1:30],Lb,Ub,runNum,"J0(x)","J0x_2.txt")
  FourierShammasSeries2(@(x)besselj(1,x),gx,[0:0.1:30],Lb,Ub,runNum,"J1(x)","J1x_2.txt")
  FourierShammasSeries2(@(x)besselj(2,x),gx,[0:0.1:30],Lb,Ub,runNum,"J2(x)","J2x_2.txt")
  FourierShammasSeries2(@(x)besselj(3,x),gx,[0:0.1:30],Lb,Ub,runNum,"J3(x)","J3x_2.txt")
  FourierShammasSeries2(@(x)besselj(4,x),gx,[0:0.1:30],Lb,Ub,runNum,"J4(x)","J4x_2.txt")
  FourierShammasSeries2(@(x)besselj(5,x),gx,[0:0.1:30],Lb,Ub,runNum,"J5(x)","J5x_2.txt")  
  FourierShammasSeries2(@(x)integral(@(z)sin(z.^2),0,x),gx,[1:0.01:5],Lb,Ub,runNum,"FresnelSine(x)","FresnelSine_2.txt")
  FourierShammasSeries2(@(x)integral(@(z)cos(z.^2),0,x),gx,[0.5:0.01:5],Lb,Ub,runNum,"FresnelCosine(x)","FresnelCosine_2.txt")
  FourierShammasSeries2(@(x)integral(@(z)sin(z)./z,0,x),gx,[1.3:0.1:20],Lb,Ub,runNum,"Si(x)","Si_2.txt")
  FourierShammasSeries2(@(x)0.57721566+log(x)-integral(@(z)(1-cos(z))./z,0,x),gx,[0.5:0.1:20],Lb,Ub,runNum,"Ci(x)","Ci_2.txt")  
  FourierShammasSeries2(@(x)asinh(x),gx,[0:0.1:100],Lb,Ub,runNum,"asinh(x)","asinh_2.txt")
  FourierShammasSeries2(@(x)acosh(x),gx,[1:0.1:100],Lb,Ub,runNum,"acosh(x)","acosh_2.txt")
  FourierShammasSeries2(@(x)atanh(x),gx,[0:0.001:0.999],Lb,Ub,runNum,"atanh(x)","atanh_2.txt")
end

if selIdx==0 || selIdx==3
  gx = @(i,A,B)A+B*sqrt(i);
  FourierShammasSeries2(@(x)acos(x),gx,[0:.01:1],Lb,Ub,runNum,"arccos(x)","arccos_3.txt")
  FourierShammasSeries2(@(x)asin(x),gx,[0:.01:1],Lb,Ub,runNum,"arcsin(x)","arcsin_3.txt")
  FourierShammasSeries2(@(x)atan(x),gx,[0:.01:1],Lb,Ub,runNum,"arctan(x)","arctan_3.txt")
  FourierShammasSeries2(@(x)tan(x),gx,[0:.01:1],Lb,Ub,runNum,"tan(x)","tan_3.txt")
  FourierShammasSeries2(@(x)sinh(x),gx,[0:.01:5],Lb,Ub,runNum,"sinh(x)","sinh_3.txt")
  FourierShammasSeries2(@(x)cosh(x),gx,[0:.01:5],Lb,Ub,runNum,"cosh(x)","cosh_3.txt")
  FourierShammasSeries2(@(x)tanh(x),gx,[0:.01:3],Lb,Ub,runNum,"tanh(x)","tanh_3.txt")
  FourierShammasSeries2(@(x)erf(x),gx,[0:.01:2.1],Lb,Ub,runNum,"erf(x)","erf_3.txt")
  FourierShammasSeries2(@(x)exp(x),gx,[0:.01:2],Lb,Ub,runNum,"exp(x)","exp_3.txt")
  FourierShammasSeries2(@(x)log(x),gx,[1:.01:10],Lb,Ub,runNum,"ln(x)","ln_3.txt")
  FourierShammasSeries2(@(x)log10(x),gx,[1:.01:10],Lb,Ub,runNum,"log(x)","log_3.txt")
  FourierShammasSeries2(@(x)10.^x,gx,[0:.01:1],Lb,Ub,runNum,"10^x","pwr10_3.txt")
  FourierShammasSeries2(@(x)tinv(0.95,x),gx,[2:0.1:100],Lb,Ub,runNum,"tinv(0.95,x)","tinv1_3.txt")
  FourierShammasSeries2(@(x)tinv(0.975,x),gx,[2:0.1:100],Lb,Ub,runNum,"tinv(0.975,x)","tinv2_3.txt")
  FourierShammasSeries2(@(x)log10(gamma(x)),gx,[2:0.1:100],Lb,Ub,runNum,"log10Gamma(x)","log10Gamma_3.txt")
  FourierShammasSeries2(@(x)digamma(x),gx,[2:0.1:100],Lb,Ub,runNum,"digamma(x)","digamma_3.txt")
  FourierShammasSeries2(@(x)trigamma(x),gx,[1:0.1:100],Lb,Ub,runNum,"trigamma(x)","trigamma_3.txt")
  FourierShammasSeries2(@(x)besselj(0,x),gx,[2:0.1:30],Lb,Ub,runNum,"J0(x)","J0x_3.txt")
  FourierShammasSeries2(@(x)besselj(1,x),gx,[0:0.1:30],Lb,Ub,runNum,"J1(x)","J1x_3.txt")
  FourierShammasSeries2(@(x)besselj(2,x),gx,[0:0.1:30],Lb,Ub,runNum,"J2(x)","J2x_3.txt")
  FourierShammasSeries2(@(x)besselj(3,x),gx,[0:0.1:30],Lb,Ub,runNum,"J3(x)","J3x_3.txt")
  FourierShammasSeries2(@(x)besselj(4,x),gx,[0:0.1:30],Lb,Ub,runNum,"J4(x)","J4x_3.txt")
  FourierShammasSeries2(@(x)besselj(5,x),gx,[0:0.1:30],Lb,Ub,runNum,"J5(x)","J5x_3.txt")   
  FourierShammasSeries2(@(x)integral(@(z)sin(z.^2),0,x),gx,[1:0.01:5],Lb,Ub,runNum,"FresnelSine(x)","FresnelSine_3.txt")
  FourierShammasSeries2(@(x)integral(@(z)cos(z.^2),0,x),gx,[0.5:0.01:5],Lb,Ub,runNum,"FresnelCosine(x)","FresnelCosine_3.txt")
  FourierShammasSeries2(@(x)integral(@(z)sin(z)./z,0,x),gx,[1.3:0.1:20],Lb,Ub,runNum,"Si(x)","Si_3.txt")
  FourierShammasSeries2(@(x)0.57721566+log(x)-integral(@(z)(1-cos(z))./z,0,x),gx,[0.5:0.1:20],Lb,Ub,runNum,"Ci(x)","Ci_3.txt")  
  FourierShammasSeries2(@(x)asinh(x),gx,[0:0.1:100],Lb,Ub,runNum,"asinh(x)","asinh_3.txt")
  FourierShammasSeries2(@(x)acosh(x),gx,[1:0.1:100],Lb,Ub,runNum,"acosh(x)","acosh_3.txt")
  FourierShammasSeries2(@(x)atanh(x),gx,[0:0.001:0.999],Lb,Ub,runNum,"atanh(x)","atanh_3.txt")
end

if selIdx==0 || selIdx==4
  gx = @(i,A,B)A+B*log(i)^4;
  FourierShammasSeries2(@(x)acos(x),gx,[0:.01:1],Lb,Ub,runNum,"arccos(x)","arccos_4.txt")
  FourierShammasSeries2(@(x)asin(x),gx,[0:.01:1],Lb,Ub,runNum,"arcsin(x)","arcsin_4.txt")
  FourierShammasSeries2(@(x)atan(x),gx,[0:.01:1],Lb,Ub,runNum,"arctan(x)","arctan_4.txt")
  FourierShammasSeries2(@(x)tan(x),gx,[0:.01:1],Lb,Ub,runNum,"tan(x)","tan_4.txt")
  FourierShammasSeries2(@(x)sinh(x),gx,[0:.01:5],Lb,Ub,runNum,"sinh(x)","sinh_4.txt")
  FourierShammasSeries2(@(x)cosh(x),gx,[0:.01:5],Lb,Ub,runNum,"cosh(x)","cosh_4.txt")
  FourierShammasSeries2(@(x)tanh(x),gx,[0:.01:3],Lb,Ub,runNum,"tanh(x)","tanh_4.txt")
  FourierShammasSeries2(@(x)erf(x),gx,[0:.01:2.1],Lb,Ub,runNum,"erf(x)","erf_4.txt")
  FourierShammasSeries2(@(x)exp(x),gx,[0:.01:2],Lb,Ub,runNum,"exp(x)","exp_4.txt")
  FourierShammasSeries2(@(x)log(x),gx,[1:.01:10],Lb,Ub,runNum,"ln(x)","ln_4.txt")
  FourierShammasSeries2(@(x)log10(x),gx,[1:.01:10],Lb,Ub,runNum,"log(x)","log_4.txt")
  FourierShammasSeries2(@(x)10.^x,gx,[0:.01:1],Lb,Ub,runNum,"10^x","pwr10_4.txt")
  FourierShammasSeries2(@(x)tinv(0.95,x),gx,[2:0.1:100],Lb,Ub,runNum,"tinv(0.95,x)","tinv1_4.txt")
  FourierShammasSeries2(@(x)tinv(0.975,x),gx,[2:0.1:100],Lb,Ub,runNum,"tinv(0.975,x)","tinv2_4.txt")
  FourierShammasSeries2(@(x)log10(gamma(x)),gx,[2:0.1:100],Lb,Ub,runNum,"log10Gamma(x)","log10Gamma_4.txt")
  FourierShammasSeries2(@(x)digamma(x),gx,[2:0.1:100],Lb,Ub,runNum,"digamma(x)","digamma_4.txt")
  FourierShammasSeries2(@(x)trigamma(x),gx,[1:0.1:100],Lb,Ub,runNum,"trigamma(x)","trigamma_4.txt")
  FourierShammasSeries2(@(x)besselj(0,x),gx,[2:0.1:30],Lb,Ub,runNum,"J0(x)","J0x_4.txt")
  FourierShammasSeries2(@(x)besselj(1,x),gx,[0:0.1:30],Lb,Ub,runNum,"J1(x)","J1x_4.txt")
  FourierShammasSeries2(@(x)besselj(2,x),gx,[0:0.1:30],Lb,Ub,runNum,"J2(x)","J2x_4.txt")
  FourierShammasSeries2(@(x)besselj(3,x),gx,[0:0.1:30],Lb,Ub,runNum,"J3(x)","J3x_4.txt")
  FourierShammasSeries2(@(x)besselj(4,x),gx,[0:0.1:30],Lb,Ub,runNum,"J4(x)","J4x_4.txt")
  FourierShammasSeries2(@(x)besselj(5,x),gx,[0:0.1:30],Lb,Ub,runNum,"J5(x)","J5x_4.txt")
  FourierShammasSeries2(@(x)integral(@(z)sin(z.^2),0,x),gx,[1:0.01:5],Lb,Ub,runNum,"FresnelSine(x)","FresnelSine_4.txt")
  FourierShammasSeries2(@(x)integral(@(z)cos(z.^2),0,x),gx,[0.5:0.01:5],Lb,Ub,runNum,"FresnelCosine(x)","FresnelCosine_4.txt")
  FourierShammasSeries2(@(x)integral(@(z)sin(z)./z,0,x),gx,[1.3:0.1:20],Lb,Ub,runNum,"Si(x)","Si_4.txt")
  FourierShammasSeries2(@(x)0.57721566+log(x)-integral(@(z)(1-cos(z))./z,0,x),gx,[0.5:0.1:20],Lb,Ub,runNum,"Ci(x)","CI_4.txt")
  FourierShammasSeries2(@(x)asinh(x),gx,[0:0.1:100],Lb,Ub,runNum,"asinh(x)","asinh_4.txt")
  FourierShammasSeries2(@(x)acosh(x),gx,[1:0.1:100],Lb,Ub,runNum,"acosh(x)","acosh_4.txt")
  FourierShammasSeries2(@(x)atanh(x),gx,[0:0.001:0.999],Lb,Ub,runNum,"atanh(x)","atanh_4.txt")
end


toc;

for i=1:7
  beep;
  pause(3)
end

if bShutdown
  system('shutdown -s');
else
  fprintf("\n\nDone!\n\n");
end